##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

"""Interfaces for schedule.
$Id: ISchedule.py,v 1.1.2.2 2002/12/11 10:19:51 jack-e Exp $
"""
from Interface import Interface

class ISchedule(Interface):
    """A Task Queue with Scheduling Policy
    """

    def schedule(task):
        """add a task to the Queue
        """

    def unschedule(task):
        """remove a task from the Queue
        """


class IScheduleControl(Interface):
    """A Task Queue Control Interface
    """

    def process(time):
        """Process due tasks
        """

    def getTaskTimes():
        """Return all datetimes for scheduled Tasks
        """    

    def getTaskInfo(time):
        """Return Tasklist with (time,principalId,description).
        """
