##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

"""Interface for ScheduleThreadManager.
$Id: $
"""


from Interface import Interface
from Interface.Attribute import Attribute


class IScheduleThreadManager(Interface):
    """ScheduleThreadManager."""

    startScheduleThreads = Attribute("""True if a Thread per Schedule should be started.""")

    def register(location, poll=5.0):
        """Register a Schedule.

        when a Schedule receives a ZopeStartupEvent it queries for an
        ScheduleService and registers itself if found.
        
        poll defines delay between polling of taskTimes.
        """

    def unregister(location):
        """Unregister a Schedule.

        when a Schedule receives a ZopeShutdownEvent or is deleted, it
        queries for a ScheduleService and unregisters itself.
        """

    def listSchedules():
        """List registered Schedules."""
