##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

"""Interfaces for task.
$Id: ITask.py,v 1.1.2.2 2002/12/11 10:19:51 jack-e Exp $
"""
from Interface import Interface

from Zope.Schema import Datetime, Line, Text

class ITask(Interface):

    time = Datetime(description=u"The time at which the task should execute",
                    readonly=1,
                    required=1)

    principalId = Line(description=
                     u"The principalId that the task should be executed as.",
                     readonly=1,
                     required=1)
    
    description = Text(description=
                       u"The description of the task for task ")

    
    def __call__():
        """Execute the task

        Exceptions raised by execute will be logged.

        If execution is sucessful, return None.

        A task may be returned to retry work after an error.
        """

    def schedule():
        """Schedule a new task

        If the execution of the task is sucessful (execute returns None),
        then schedule is called to optionally (re)schedule a task.

        None may be returned if no task needs to be scheduled.

        This method is used to implement repeating tasks.
        """


