##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

"""Implementation of Task.

$Id: Task.py,v 1.1.2.2 2002/12/11 10:19:51 jack-e Exp $
"""
from Zope.ContextWrapper import ContextMethod

from Zope.App.Tasks.ITask import ITask


class Task:
    """Generic Task
    """

    __implements__ = ITask

    time = None

    principalId = None

    description = ''
 
    def __init__(self, time, principalId, func=None, *args, **kw):
        self.time = time
        self.principalId = principalId
        self._func = func
        self._args = args
        self._kw = kw

    #######################################################
    # Basic Implementation for Interface ITask

    def __call__(self):
        if callable(self._func):
            return apply(self._func, self._args, self._kw)

    __call__ = ContextMethod(__call__)

    def schedule(self):
        return None

    #
    #######################################################

